#include "o3d.h"

#include "chess_tex.h"

COLOR3D chess_KNIGHT8_col_0 = {0,0,255};
#define CHESS_KNIGHT8_NBV 37

VERTEX3D chess_KNIGHT8_v[CHESS_KNIGHT8_NBV] = {
{-8,-8,0},
{-8,-8,3},
{-8,8,0},
{-8,8,3},
{8,8,3},
{8,8,0},
{8,-8,0},
{8,-8,3},
{7,-7,3},
{-7,-7,3},
{7,7,3},
{-7,7,3},
{-7,-7,4},
{-7,7,4},
{7,7,4},
{7,-7,4},
{7,-7,4},
{-7,-7,4},
{7,7,4},
{-7,7,4},
{-3,7,4},
{7,-7,16},
{3,-7,16},
{7,7,16},
{-7,-7,16},
{-7,7,16},
{0,7,4},
{3,7,4},
{-3,-7,16},
{-3,0,24},
{-3,7,32},
{3,0,24},
{3,7,32},
{-3,7,24},
{3,7,24},
{7,7,32},
{-7,7,32}
};

VERTEX3D chess_KNIGHT8_bb[8] = {
{-8,8,32},{8,8,32},{8,-8,32},{-8,-8,32},
{-8,8,0},{8,8,0},{8,-8,0},{-8,-8,0}
};

VECTOR3D chess_KNIGHT8_vn[CHESS_KNIGHT8_NBV] = {
{-457,-915,0},
{-871,-435,315},
{-915,457,0},
{-435,871,315},
{871,435,315},
{457,915,0},
{915,-457,0},
{435,-871,315},
{751,-375,584},
{-375,-751,584},
{375,751,584},
{-751,375,584},
{-777,-388,-542},
{-369,738,-606},
{814,407,-467},
{388,-777,-542},
{865,-541,-80},
{-505,-885,-94},
{720,720,-100},
{-723,723,-29},
{0,0,-1024},
{918,-364,267},
{0,-971,324},
{743,704,0},
{-966,-271,199},
{-697,749,0},
{0,0,-1024},
{0,0,-1024},
{0,-946,390},
{174,-522,862},
{571,0,849},
{-275,-550,818},
{-571,0,849},
{497,746,492},
{-247,864,489},
{994,0,246},
{-994,0,246}
};

#define CHESS_KNIGHT8_NBT 65

TRIANGLE3D chess_KNIGHT8_t[CHESS_KNIGHT8_NBT] = {
{2,1,0,COLORED,{&chess_KNIGHT8_col_0}},
{2,3,1,COLORED,{&chess_KNIGHT8_col_0}},
{3,5,4,COLORED,{&chess_KNIGHT8_col_0}},
{3,2,5,COLORED,{&chess_KNIGHT8_col_0}},
{6,4,5,COLORED,{&chess_KNIGHT8_col_0}},
{6,7,4,COLORED,{&chess_KNIGHT8_col_0}},
{0,7,6,COLORED,{&chess_KNIGHT8_col_0}},
{0,1,7,COLORED,{&chess_KNIGHT8_col_0}},
{1,8,7,COLORED,{&chess_KNIGHT8_col_0}},
{1,9,8,COLORED,{&chess_KNIGHT8_col_0}},
{7,10,4,COLORED,{&chess_KNIGHT8_col_0}},
{7,8,10,COLORED,{&chess_KNIGHT8_col_0}},
{4,11,3,COLORED,{&chess_KNIGHT8_col_0}},
{4,10,11,COLORED,{&chess_KNIGHT8_col_0}},
{3,9,1,COLORED,{&chess_KNIGHT8_col_0}},
{3,11,9,COLORED,{&chess_KNIGHT8_col_0}},
{11,12,9,COLORED,{&chess_KNIGHT8_col_0}},
{11,13,12,COLORED,{&chess_KNIGHT8_col_0}},
{10,13,11,COLORED,{&chess_KNIGHT8_col_0}},
{10,14,13,COLORED,{&chess_KNIGHT8_col_0}},
{8,14,10,COLORED,{&chess_KNIGHT8_col_0}},
{8,15,14,COLORED,{&chess_KNIGHT8_col_0}},
{9,15,8,COLORED,{&chess_KNIGHT8_col_0}},
{9,12,15,COLORED,{&chess_KNIGHT8_col_0}},
{12,16,15,COLORED,{&chess_KNIGHT8_col_0}},
{12,17,16,COLORED,{&chess_KNIGHT8_col_0}},
{15,18,14,COLORED,{&chess_KNIGHT8_col_0}},
{15,16,18,COLORED,{&chess_KNIGHT8_col_0}},
{20,19,13,COLORED,{&chess_KNIGHT8_col_0}},
{13,17,12,COLORED,{&chess_KNIGHT8_col_0}},
{13,19,17,COLORED,{&chess_KNIGHT8_col_0}},
{22,21,16,COLORED,{&chess_KNIGHT8_col_0}},
{16,23,18,COLORED,{&chess_KNIGHT8_col_0}},
{16,21,23,COLORED,{&chess_KNIGHT8_col_0}},
{19,24,17,COLORED,{&chess_KNIGHT8_col_0}},
{19,25,24,COLORED,{&chess_KNIGHT8_col_0}},
{14,27,26,COLORED,{&chess_KNIGHT8_col_0}},
{13,14,26,COLORED,{&chess_KNIGHT8_col_0}},
{14,18,27,COLORED,{&chess_KNIGHT8_col_0}},
{13,26,20,COLORED,{&chess_KNIGHT8_col_0}},
{17,24,28,COLORED,{&chess_KNIGHT8_col_0}},
{30,29,24,COLORED,{&chess_KNIGHT8_col_0}},
{22,31,21,COLORED,{&chess_KNIGHT8_col_0}},
{17,22,16,COLORED,{&chess_KNIGHT8_col_0}},
{17,28,22,COLORED,{&chess_KNIGHT8_col_0}},
{32,21,31,COLORED,{&chess_KNIGHT8_col_0}},
{28,24,29,COLORED,{&chess_KNIGHT8_col_0}},
{29,22,28,COLORED,{&chess_KNIGHT8_col_0}},
{29,31,22,COLORED,{&chess_KNIGHT8_col_0}},
{34,29,33,COLORED,{&chess_KNIGHT8_col_0}},
{34,31,29,COLORED,{&chess_KNIGHT8_col_0}},
{32,35,21,COLORED,{&chess_KNIGHT8_col_0}},
{30,24,36,COLORED,{&chess_KNIGHT8_col_0}},
{35,23,21,COLORED,{&chess_KNIGHT8_col_0}},
{24,25,36,COLORED,{&chess_KNIGHT8_col_0}},
{31,34,32,COLORED,{&chess_KNIGHT8_col_0}},
{33,29,30,COLORED,{&chess_KNIGHT8_col_0}},
{23,19,18,COLORED,{&chess_KNIGHT8_col_0}},
{23,25,19,COLORED,{&chess_KNIGHT8_col_0}},
{34,25,23,COLORED,{&chess_KNIGHT8_col_0}},
{34,33,25,COLORED,{&chess_KNIGHT8_col_0}},
{25,30,36,COLORED,{&chess_KNIGHT8_col_0}},
{25,33,30,COLORED,{&chess_KNIGHT8_col_0}},
{32,23,35,COLORED,{&chess_KNIGHT8_col_0}},
{32,34,23,COLORED,{&chess_KNIGHT8_col_0}}
};

VECTOR3D chess_KNIGHT8_tn[CHESS_KNIGHT8_NBT] = {
{-1024,0,0},
{-1024,0,0},
{0,1024,0},
{0,1024,0},
{1024,0,0},
{1024,0,0},
{0,-1024,0},
{0,-1024,0},
{0,0,1024},
{0,0,1024},
{0,0,1024},
{0,0,1024},
{0,0,1024},
{0,0,1024},
{0,0,1024},
{0,0,1024},
{-1024,0,0},
{-1024,0,0},
{0,1024,0},
{0,1024,0},
{1024,0,0},
{1024,0,0},
{0,-1024,0},
{0,-1024,0},
{0,0,-1024},
{0,0,-1024},
{0,0,-1024},
{0,0,-1024},
{0,0,-1024},
{0,0,-1024},
{0,0,-1024},
{0,-1024,0},
{1024,0,0},
{1024,0,0},
{-1024,0,0},
{-1024,0,0},
{0,0,-1024},
{0,0,-1024},
{0,0,-1024},
{0,0,-1024},
{0,-1024,0},
{0,-727,720},
{0,-727,720},
{0,-1024,0},
{0,-1024,0},
{0,-727,720},
{0,-727,720},
{0,-727,720},
{0,-727,720},
{0,0,1024},
{0,0,1024},
{0,-727,720},
{0,-727,720},
{1024,0,0},
{-1024,0,0},
{-1024,0,0},
{1024,0,0},
{0,1024,0},
{0,1024,0},
{0,1024,0},
{0,1024,0},
{0,1024,0},
{0,1024,0},
{0,1024,0},
{0,1024,0}
};

OBJECT3D chess_KNIGHT8 =
{
CHESS_KNIGHT8_NBV,
chess_KNIGHT8_v,
chess_KNIGHT8_vn,
CHESS_KNIGHT8_NBT,
chess_KNIGHT8_t,
chess_KNIGHT8_tn,
chess_KNIGHT8_bb
};

